#include "fbgfx.bi"
#include "multiput.bi"

type TypeCoord
  as integer x, y
end type

declare function click as TypeCoord
declare sub game(swapTiles as integer)
declare sub tileFlip(coord as TypeCoord, number as integer, direction as integer)
declare sub tileShow(coord as TypeCoord, number as integer)
declare sub tileSwap(coord1 as TypeCoord, coord2 as TypeCoord)
declare sub timeShow

chdir exepath
randomize
screenres 800, 440, 32
width 100, 27
color 0, &hffffff
cls

dim shared as integer rows = 6, determinate
dim as integer swapTiles = -1, x, y, button
dim shared as FB.IMAGE ptr img(12), empty
dim shared as any ptr timethread, mutex
mutex = mutexcreate

' Bilder einlesen
empty = imagecreate(100, 100, &hffffff)
img(0) = imagecreate(100, 100)
bload "img/background.bmp", img(0)
for i as integer = 1 to 12
  img(i) = imagecreate(100, 100)
  bload "img/tile" & i & ".bmp", img(i)
next

do
  ' Menue zeichnen
  screenlock
  cls
  for i as integer = 3 to 6
    circle (325, 40*i-33), 10
    draw string (350, 40*i-40), "Spiel mit 2x" & 2*i & " Feldern"
    if rows = i then circle (325, 40*i-33), 6,,,,, F
  next
  draw string (350, 260), "Felder tauschen"
  line (315, 257)-step(20, 20),, B
  if swapTiles then
    line (315, 257)-step(20, 20)
    line step(-20, 0)-step(20, -20)
  end if
  line (315, 320)-step(90, 20),, B
  line (440, 320)-step(90, 20),, B
  draw string (335, 323), "Spielen"
  draw string (460, 323), "Beenden"
  line (300, 50)-step(250, 320),, B
  line (298, 48)-step(254, 324),, B
  screenunlock
  ' Mauseingabe auswerten
  do
    getmouse x, y,, button
    if inkey = chr(255, 107) then end
    sleep 1
  loop until button = 1
  ' Anzahl der Felder augewaehlt
  for i as integer = 3 to 6
    if (x-325)*(x-325) + (y-40*i+33)*(y-40*i+33) < 100 then
      circle (325, 40*rows-33), 8, &hffffff,,,, F
      rows = i
      circle (325, 40*i-33), 6,,,,, F
    end if
  next
  ' Auswahl des Feldertausches
  if x > 315 and x < 335 and y > 257 and y < 277 then
    swapTiles = not swapTiles
    if swapTiles then
      line (315, 257)-step(20, 20)
      line step(-20, 0)-step(20, -20)
    end if
  end if
  ' Buttons Spielstart bzw. Spielende
  if x > 315 and x < 405 and y > 320 and y < 340 then game(swapTiles)
  if x > 440 and x < 530 and y > 320 and y < 340 then end
  do
    getmouse x, y,, button
    sleep 1
  loop until button = 0
loop until len(inkey)

sub game(swapTiles as integer)
  dim as integer tile(5, 3), found = 0, turns = 0, x, y, button
  dim as string key
  dim as TypeCoord coord1, coord2
  do
    getmouse x, y,, button
    sleep 1
  loop until button = 0
  ' Spielfeld zeichnen
  cls
  for i as integer = 1 to 4*rows
    with coord1
      do
        .x = int(rnd*rows)
        .y = int(rnd*4)
      loop until tile(.x, .y) = 0
      tile(.x, .y) = (i+1)\2
    end with
    tileShow coord1, 0
  next
  locate 6, 85 : print !"Z\129ge: " & turns
  determinate = 0
  timethread = threadcreate(cast(any ptr, @timeShow))
  ' Spielbeginn
  do
    ' erstes Feld anklicken
    do
      coord1 = click
      if coord1.x < 0 or coord1.y < 0 or coord1.x >= rows or coord1.y > 3 then continue do
      if tile(coord1.x, coord1.y) > 0 then exit do
    loop
    tileFlip coord1, tile(coord1.x, coord1.y), 1
    ' zweites Feld anklicken
    do
      coord2 = click
      if coord2.x < 0 or coord2.y < 0 or coord2.x >= rows or coord2.y > 3 then continue do
      if coord2.x = coord1.x and coord2.y = coord1.y then continue do
      if tile(coord2.x, coord2.y) > 0 then exit do
    loop
    tileFlip coord2, tile(coord2.x, coord2.y), 1
    turns += 1
    mutexlock mutex
    locate 6, 85 : print !"Z\129ge: " & turns
    mutexunlock mutex
    if tile(coord1.x, coord1.y) = tile(coord2.x, coord2.y) then
      ' passendes Paar gefunden
      tileFlip coord1, tile(coord1.x, coord1.y), -1
      tileFlip coord2, tile(coord2.x, coord2.y), -1
      tile(coord1.x, coord1.y) = 0
      tile(coord2.x, coord2.y) = 0
      found += 1
    elseif swapTiles then
      ' Kaertchen vertauschen
      tileSwap coord1, coord2
      sleep 500, 1
      swap tile(coord1.x, coord1.y), tile(coord2.x, coord2.y)
      tileFlip coord1, tile(coord1.x, coord1.y), 0
      tileFlip coord2, tile(coord2.x, coord2.y), 0
    else
      ' alles bleibt beim alten; Kaertchen umdrehen
      tileFlip coord1, tile(coord1.x, coord1.y), 0
      tileFlip coord2, tile(coord2.x, coord2.y), 0
    end if
    if inkey = chr(255, 107) then end
  loop until found = rows*2
  mutexlock mutex
  determinate = -1
  mutexunlock mutex
  threadwait timethread
  timethread = 0
  cls
  line (330, 120)-step(170, 120),, B
  locate 10, 45 : print "Spiel beendet"
  locate 12, 45 : print "in " & turns & !" Z\129gen und"
  locate 14, 45 : print determinate & !" Sekunden"
  do
    getmouse x, y,, button
    key = inkey
    if key = chr(255, 107) then end
    sleep 1
  loop until (button = 1) or len(key)
end sub

sub destruct destructor
  ' aufraeumen bei Spielende
  if timethread then
    mutexlock mutex
    determinate = 1
    mutexunlock mutex
    threadwait timethread
  end if
  mutexdestroy mutex
  for i as integer = 0 to 12
    imagedestroy img(i)
  next
  imagedestroy empty
end sub

function click as TypeCoord
  ' Mausklick auf ein Feld abwarten und Koordinaten zurückgeben
  dim as TypeCoord ret
  dim as integer x, y, button
  do
    mutexlock mutex
    getmouse x, y,, button
    if inkey = chr(255, 107) then end
    mutexunlock mutex
    sleep 1
  loop until button = 1
  ret.x = (x+rows*50-220)\100 - 1
  ret.y = (y+80)\100 - 1
  do
    mutexlock mutex
    getmouse x, y,, button
    if inkey = chr(255, 107) then end
    mutexunlock mutex
    sleep 1
  loop until button = 0
  if ret.x <> (x+rows*50-320)\100 or ret.y <> (y-20)\100 then ret.x = -1 : ret.y = -1
  return ret
end function

sub tileFlip(coord as TypeCoord, number as integer, direction as integer)
  ' Kaertchen umdrehen (grafische Darstellung)
  ' direction =  1:  verdecktes Kaertchen aufdecken
  '           = -1:  Kaertchen aus dem Spiel nehmen
  '           sonst: offenes Feld zudecken
  with coord
    for i as integer = 1 to 25
      mutexlock mutex
      screenlock
      put (.x*100+320-rows*50, .y*100+20), empty, pset
      multiput , .x*100+369-rows*50, .y*100+70, iif(direction = 1, img(0), img(number)), (25-i)/25
      screenunlock
      mutexunlock mutex
      sleep 10
    next
    if direction = -1 then
      mutexlock mutex
      put (.x*100+320-rows*50, .y*100+20), empty, pset
      mutexunlock mutex
      exit sub
    end if
    for i as integer = 1 to 24
      mutexlock mutex
      screenlock
      put (.x*100+320-rows*50, .y*100+20), empty, pset
      multiput , .x*100+369-rows*50, .y*100+70, iif(direction = 1, img(number), img(0)), i/25
      screenunlock
      mutexunlock mutex
      sleep 10
    next
    if direction = 1 then
      mutexlock mutex
      put (.x*100+320-rows*50, .y*100+20), img(number), pset
      mutexunlock mutex
    else
      mutexlock mutex
      put (.x*100+320-rows*50, .y*100+20), img(0), pset
      mutexunlock mutex
    end if
  end with
end sub

sub tileShow(coord as TypeCoord, number as integer)
  ' Kaertchen zeichnen
  mutexlock mutex
  put (coord.x*100+320-rows*50, coord.y*100+20), img(number), pset
  mutexunlock mutex
end sub

sub tileSwap(coord1 as TypeCoord, coord2 as TypeCoord)
  ' Kaertchen zweier Felder vertauschen (grafische Darstellung)
  dim as FB.IMAGE ptr img1 = imagecreate(100, 100), img2 = imagecreate(100, 100), background = imagecreate(800, 440)
  mutexlock mutex
  get (coord1.x*100+320-rows*50, coord1.y*100+20)-step(99, 99), img1
  get (coord2.x*100+320-rows*50, coord2.y*100+20)-step(99, 99), img2
  put (coord1.x*100+320-rows*50, coord1.y*100+20), empty, pset
  put (coord2.x*100+320-rows*50, coord2.y*100+20), empty, pset
  get (0, 0)-(799, 439), background
  put (coord1.x*100+320-rows*50, coord1.y*100+20), img1, pset
  put (coord2.x*100+320-rows*50, coord2.y*100+20), img2, pset
  mutexunlock mutex
  for i as integer = 1 to 100
    mutexlock mutex
    screenlock
    put (0, 0), background, pset
    put (coord1.x*100+320-rows*50 + i*(coord2.x-coord1.x), coord1.y*100+20 + i*(coord2.y-coord1.y)), img1, pset
    put (coord2.x*100+320-rows*50 + i*(coord1.x-coord2.x), coord2.y*100+20 + i*(coord1.y-coord2.y)), img2, pset
    screenunlock
    mutexunlock mutex
    sleep 10
  next
  mutexunlock mutex
  imagedestroy img1
  imagedestroy img2
  imagedestroy background
end sub

sub timeShow
  color 0, &hffffff
  dim as double t = timer
  dim as integer sec = 0
  do
    mutexlock mutex
    if determinate then exit do
    if timer - t > 1 then
      sec += 1
      t = timer
      locate 9, 85 : print !"Zeit: " & sec
    end if
    mutexunlock mutex
    sleep 1
  loop
  determinate = sec
  mutexunlock mutex
end sub
